format short e;

%DIFFERENZIEREN

dfexakt=-32/289;
erg1=bdf1(@f, 1, 1);
fprintf('\n1. Ordnung\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

for i=1:1:20
fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erg1(i,1:4)); 
end;

figure(1)
loglog(erg1(1:20,2),erg1(1:20,3));
title ('Verlauf des Fehlers')
xlabel ('Maschenweite h')
ylabel ('Fehler')
grid on;
hold on;

figure (2);
y=(-0.5):0.01:1.5;
f_1=1./(1+16*y.^2);
f_2=(2048*y.^2)./(16*y.^2 + 1).^3 - 32./(16*y.^2 + 1).^2;

plot (y,f_1,y,f_2);
normf=norm(f_1, inf);
normf_2=norm(f_2, inf);
h_opt=sqrt((4*eps*normf)/normf_2);
fprintf('\nh optimal: %e\n',h_opt);
hold on;

%erge=dfexakt-bdf1(@f,1,[sqrt(eps)]);
%fprintf('\nEpsilon\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

%for i=1:1:20
%fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erge(i,1:4)); 
%end;


erg2=bdf2(@f, 1, 1);
fprintf('\n2. Ordnung\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

for i=1:1:20
fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erg2(i,1:4)); 
end;

figure(1)
loglog(erg2(1:20,2),erg2(1:20,3));
title ('Verlauf des Fehlers')
xlabel ('Maschenweite h')
ylabel ('Fehler')
grid on;
hold on;

erg3=bdf3(@f, 1, 1);
fprintf('\n3. Ordnung\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

for i=1:1:20
fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erg3(i,1:4)); 
end;

figure(1)
loglog(erg3(1:20,2),erg3(1:20,3));
title ('Verlauf des Fehlers')
xlabel ('Maschenweite h')
ylabel ('Fehler')
grid on;


erg4=zd2(@f, 1, 1);
fprintf('\nZentrale Differenz\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

for i=1:1:20
fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erg4(i,1:4)); 
end;

figure(3)
loglog(erg4(1:20,2),erg4(1:20,3));
title ('Verlauf des Fehlers')
xlabel ('Maschenweite h')
ylabel ('Fehler')
grid on;
hold on;

erg5=zd4(@f, 1, 1);
fprintf('\nZentrale Differenz\ni\t\th_i\t\t\t\tFehler\t\t\tAbleitung\t\n');

for i=1:1:20
fprintf('%1.0f\t%15.5e\t%15.5e\t%15.5e\n',erg5(i,1:4)); 
end;

figure(3)
loglog(erg5(1:20,2),erg5(1:20,3));
title ('Verlauf des Fehlers')
xlabel ('Maschenweite h')
ylabel ('Fehler')
grid on;

%DIFFERENZIALGLEICHUNGEN

%EULER

m=2;
k=1;
tspan(1)=0;
tspan(2)=40;
dt=1E-3;
N=(tspan(2)-tspan(1))/dt;

y0=[-1;0;-1;0];
[talpha,yalpha]=euler( @rhsODE, tspan, y0, N, m, k );

y0=[-1;0;1;0];
[tbeta,ybeta]=euler( @rhsODE, tspan, y0, N, m, k );

y0=[1;0;0;0];
[tgamma,ygamma]=euler( @rhsODE, tspan, y0, N, m, k );


figure(4);
subplot(2,1,1);
plot(talpha,yalpha(:,1));
title ('Euler-Verfahren Lsg. Alpha 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(talpha,yalpha(:,3));
title ('Euler-Verfahren Lsg. Alpha 3');
xlabel ('t');
ylabel ('y');
grid on;

figure(5);
subplot(2,1,1);
plot(tbeta,ybeta(:,1));
title ('Euler-Verfahren Lsg. Beta 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(tbeta,ybeta(:,3));
title ('Euler-Verfahren Lsg. Beta 3');
xlabel ('t');
ylabel ('y');
grid on;

figure(6);
subplot(2,1,1);
plot(tgamma,ygamma(:,1));
title ('Euler-Verfahren Lsg. Gamma 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(tgamma,ygamma(:,3));
title ('Euler-Verfahren Lsg. Gamma 3');
xlabel ('t');
ylabel ('y');
grid on;

%SCHWINGUNGSDAUER

A=diag([1/m ,  1/m])*[-2*k k; k -2*k];
[V, D] = eig(A);

fprintf('\nSchwingungsdauer Alpha: %5.5f\n',2*pi/sqrt(-D(2,2)));
fprintf('Schwingungsdauer Beta : %5.5f\n',2*pi/sqrt(-D(1,1)));

%RUNGE KUTTA


y0=[-1;0;-1;0];
[talpha,yalpha]=ode45( @rhsODE, tspan, y0, [], m, k );

y0=[-1;0;1;0];
[tbeta,ybeta]=ode45( @rhsODE, tspan, y0, [], m, k );

y0=[1;0;0;0];
[tgamma,ygamma]=ode45( @rhsODE, tspan, y0, [], m, k );

figure(7);
subplot(2,1,1);
plot(talpha,yalpha(:,1));
title ('Runge-Kutta-Verfahren Lsg. Alpha 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(talpha,yalpha(:,3));
title ('Runge-Kutta-Verfahren Lsg. Alpha 3');
xlabel ('t');
ylabel ('y');
grid on;

figure(8);
subplot(2,1,1);
plot(tbeta,ybeta(:,1));
title ('Runge-Kutta-Verfahren Lsg. Beta 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(tbeta,ybeta(:,3));
title ('Runge-Kutta-Verfahren Lsg. Beta 3');
xlabel ('t');
ylabel ('y');
grid on;

figure(9);
subplot(2,1,1);
plot(tgamma,ygamma(:,1));
title ('Runge-Kutta-Verfahren Lsg. Gamma 1');
xlabel ('t');
ylabel ('y');
grid on;
subplot(2,1,2);
plot(tgamma,ygamma(:,3));
title ('Runge-Kutta-Verfahren Lsg. Gamma 3');
xlabel ('t');
ylabel ('y');
grid on;
