function [ t, Y ] = euler( rhsODE, tspan, y0, N, m, k ) %gegeben
    n = length(y0);                 % Anzahl Komponenten
    dt = (tspan(2) - tspan(1)) / N; % Maschenweite
    t = zeros(N+1, 1);
    Y = zeros(N+1, n);
    % Anfangsbedingung
    for j = 1:n
        Y(1,j) = y0(j);
    end
    % N Zeitschritte
    for i = 1:N
        t(i+1) = t(i) + dt;         % neuer Zeitpunkt
        Y(i+1,:) = Y(i,:) + dt * (rhsODE(t, Y(i,:)', m, k ) )'; %neuer Wert
    end
end
